// ListViewTest.cpp : Defines the entry point for the application.
//

#include <windows.h>
#include <commctrl.h>
#include <shellapi.h>

LRESULT CALLBACK LVTWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
BOOL InitItems(HWND hwndLV);
BOOL WINAPI InitListViewImageLists(HWND hwndLV);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;
	WNDCLASS wndclass;
	HWND hWndMain;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hbrBackground = (HBRUSH)(COLOR_WINDOW);
	wndclass.hCursor = LoadCursor(NULL, MAKEINTRESOURCE(IDC_ARROW));
	wndclass.hIcon = NULL;
	wndclass.hInstance = hInstance;
	wndclass.lpszClassName = L"ListViewTestClass";
	wndclass.lpszMenuName = NULL;
	wndclass.style = 0;
	wndclass.lpfnWndProc = LVTWndProc;
 	RegisterClass(&wndclass);

	InitCommonControls();

	hWndMain = CreateWindow(L"ListViewTestClass", L"My Window", WS_OVERLAPPEDWINDOW, 10, 10, 400, 400, NULL, NULL, hInstance, NULL);
	ShowWindow(hWndMain, nCmdShow);
	UpdateWindow(hWndMain);

    while (GetMessage(&msg, (HWND) NULL, 0, 0)) 
    { 
        TranslateMessage(&msg); 
        DispatchMessage(&msg); 
    } 
	return msg.wParam;
}

LRESULT CALLBACK LVTWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HWND hWndListView;
	switch (uMsg)
	{
	case WM_CREATE:
		hWndListView = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_NOPARENTNOTIFY, WC_LISTVIEW, L"Test", LVS_ALIGNLEFT | LVS_AUTOARRANGE | LVS_SINGLESEL | LVS_SHOWSELALWAYS | LVS_ICON | WS_CHILD | WS_VISIBLE | WS_TABSTOP, 0, 0, 100, 100, hWnd, NULL, GetModuleHandle(NULL), NULL);
		InitListViewImageLists(hWndListView);
		InitItems(hWndListView);
		ListView_SetItemState(hWndListView, 0, LVIS_SELECTED, LVIS_SELECTED);
		SetFocus(hWndListView);
//		ShowWindow(hWndListView, SW_SHOW);
		return 0;
	case WM_CLOSE:
		PostQuitMessage(0);
		return 0;
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
}

BOOL WINAPI InitListViewImageLists(HWND hwndLV) 
{ 
    HICON hiconItem;        // icon for list view items 
    HIMAGELIST himlLarge;   // image list for icon view 
    HIMAGELIST himlSmall;   // image list for other views 
 
    // Create the full-sized and small icon image lists. 
    himlLarge = ImageList_Create(GetSystemMetrics(SM_CXICON), 
        GetSystemMetrics(SM_CYICON), TRUE, 1, 1); 
    himlSmall = ImageList_Create(GetSystemMetrics(SM_CXSMICON), 
        GetSystemMetrics(SM_CYSMICON), TRUE, 1, 1); 
 
    // Add an icon to each image list. 
    hiconItem = ExtractIcon(GetModuleHandle(NULL), L"inetcpl.cpl", -4480); 
    ImageList_AddIcon(himlLarge, hiconItem); 
    ImageList_AddIcon(himlSmall, hiconItem); 
    DeleteObject(hiconItem); 
	hiconItem = ExtractIcon(GetModuleHandle(NULL), L"inetcpl.cpl", 1);
    ImageList_AddIcon(himlLarge, hiconItem); 
    ImageList_AddIcon(himlSmall, hiconItem); 
    DeleteObject(hiconItem); 
 
    // Assign the image lists to the list view control. 
    ListView_SetImageList(hwndLV, himlLarge, LVSIL_NORMAL); 
    ListView_SetImageList(hwndLV, himlSmall, LVSIL_SMALL); 

    return TRUE; 
}

BOOL InitItems(HWND hwndLV)
{
	LVITEM lvitem;
    LVCOLUMN lvc; 

	lvitem.iItem = 0;
	lvitem.iSubItem = 0;
	lvitem.pszText = L"Test";
	lvitem.iImage = 0;
	lvitem.mask = LVIF_TEXT | LVIF_IMAGE;
	ListView_InsertItem(hwndLV, &lvitem);

	lvitem.iItem = 1;
	lvitem.pszText = L"Test2";
	lvitem.iImage = 1;
	ListView_InsertItem(hwndLV, &lvitem);

    // Initialize the LVCOLUMN structure. 
    lvc.mask = LVCF_FMT | LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM; 
    lvc.fmt = LVCFMT_LEFT; 
    lvc.cx = 100; 
	lvc.pszText = L"Testing";
	lvc.iSubItem = 0;
	ListView_InsertColumn(hwndLV, 0, &lvc);
	return TRUE;
}